Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members Related Pages

# ParamColorC Class Reference

Color parameter class. More...

`#include <ParamI.h>`

Inheritance diagram for ParamColorC:

List of all members.

## Public Member Functions
virtual Edit::DataBlockI * | create ()
| Creates new parameter.
virtual Edit::DataBlockI * | create (Edit::EditableI *pOriginal)
| Creates new datablock, with reference to the original.
virtual void | copy (Edit::EditableI *pEditable)
| Deep copy from a data block, see Edit::DataBlockI::copy().
virtual void | restore (Edit::EditableI *pEditable)
| Shallow copy from a editable, see Edit::EditableI::restore().
virtual PajaTypes::uint32 | get_type () const
| Returns the type of the parameter.
virtual void | set_controller (ControllerC *cnt)
| Sets the controller of the parameter.
virtual ControllerC * | get_controller ()
| Returns the conroller attached to the parameter.
virtual void | set_increment (PajaTypes::float32 inc)
| Set spinner increment (ignored for color parameter).
virtual PajaTypes::float32 | get_increment () const
| Returns the spinner increment.
virtual bool | get_min_max (PajaTypes::float32 *pMin, PajaTypes::float32 *pMax)
| Returns the range of the parameter.
virtual void | set_style (PajaTypes::uint32 style)
| Sets the style of the parameter.
virtual PajaTypes::uint32 | get_style () const
| Returns the style of the parameter.
virtual void | set_id (PajaTypes::uint32 id)
| Sets the ID of the parmeter.
virtual PajaTypes::uint32 | get_id () const
| Returns the ID of the parameter.
virtual PajaTypes::uint32 | set_val (PajaTypes::int32 t, const PajaTypes::ColorC &val)
| Sets the value of the parameter at specified time.
virtual void | get_val (PajaTypes::int32 t, PajaTypes::ColorC &val)
| Gets the value of the parameter at specified time.
virtual PajaTypes::uint32 | save (FileIO::SaveC *pSave)
| Serialize the parameter to a Demopaja output stream.
virtual PajaTypes::uint32 | load (FileIO::LoadC *pLoad)
| Serialize the parameter from a Demopaja input stream.
## Static Public Member Functions
ParamColorC * | create_new (GizmoI *pParent, const char *szName, const PajaTypes::ColorC &rValue, PajaTypes::uint32 ui32ID, PajaTypes::uint32 ui32Style=PARAM_STYLE_COLORPICKER, bool bAnimatable=true)
| Creates a new color parameter.
## Protected Member Functions
| ParamColorC ()
| Default constructor.
| ParamColorC (GizmoI *pParent, const char *name, const PajaTypes::ColorC &value, PajaTypes::uint32 id, PajaTypes::uint32 style=PARAM_STYLE_COLORPICKER, bool animatable=true)
| Constructor.
| ParamColorC (Edit::EditableI *pOriginal)
| Constructor with reference to the original.
virtual | ~ParamColorC ()
| Default destructor.

## Detailed Description

Color parameter class.

The color parameter class can be used to control four component color variables. The components are R, G, B, A. It's up to the user how the components are threated. Colors are chosen using a color picker type-in.

The color parameter can only be used to control color values from 0 to 1. The values are shown in the GUI in range 0 to 255.

A new color parameter is created using the create_new() static method.

## Constructor & Destructor Documentation

ParamColorC | ( |  | ) | `[protected]`

| Default constructor.

ParamColorC | ( | GizmoI * | pParent,
|  | const char * | name,
|  | const PajaTypes::ColorC & | value,
|  | PajaTypes::uint32 | id,
|  | PajaTypes::uint32 | style = PARAM_STYLE_COLORPICKER,
|  | bool | animatable = true
| ) | `[protected]`

| Constructor.

ParamColorC | ( | Edit::EditableI * | pOriginal | ) | `[protected]`

| Constructor with reference to the original.

virtual ~ParamColorC | ( |  | ) | `[protected, virtual]`

| Default destructor.

## Member Function Documentation

virtual void copy | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Deep copy from a data block, see Edit::DataBlockI::copy(). Reimplemented from ParamI.

virtual Edit::DataBlockI* create | ( | Edit::EditableI * | pOriginal | ) | `[virtual]`

  | Creates new datablock, with reference to the original. Parameters:
  pOriginal | Pointer to the original editable. This method is used by the undo system to create a copy of the editable while keeping reference to the original.
The method restore() is used to restore the data from the original copy. Implements EditableI.

virtual Edit::DataBlockI* create | ( |  | ) | `[virtual]`

| Creates new parameter. Following default values are used:
                pParent = 0,
                szName = 0,
                rValue = (0, 0, 0, 1), //RGBA
                ui32ID = 0,
                ui32Style = 0,
                bAnimatable = false,
See also: create_new Implements EditableI.

ParamColorC* create_new | ( | GizmoI * | pParent,
|  | const char * | szName,
|  | const PajaTypes::ColorC & | rValue,
|  | PajaTypes::uint32 | ui32ID,
|  | PajaTypes::uint32 | ui32Style = PARAM_STYLE_COLORPICKER,
|  | bool | bAnimatable = true
| ) | `[static]`

  | Creates a new color parameter. Parameters:
  pParent | Pointer to the parent gizmo.
  szName | The name of the parameter as NULL terminated string.
  rValue | Start value of the parameter.
  ui32ID | ID of the parameter.
  ui32Style | The style of the parameter. Must be PARAM_STYLE_COLORPICKER. Default PARAM_STYLE_COLORPICKER.
  bAnimatable | If set true the parameter is animatable, else it's not (you may use PARAM_ANIMATABLE or PARAM_NOT_ANIMATABLE too). Default true.
The only type-in style is color picker. The range and the spinner increment are set internally. Example: This example creates new parameter. The name of the parameter is "Color", it's default value is opaque white and it's ID is ID_COLOR (constant defined by the plugin writer), the type-in style is color picker, the parameter can be animated.
                m_pParamColor = ParamColorC::create_new( this, "Color", ColorC( 1, 1, 1, 1 ), ID_COLOR,
                                                            PARAM_STYLE_COLORPICKER, PARAM_ANIMATABLE );

virtual ControllerC* get_controller | ( |  | ) | `[virtual]`

| Returns the conroller attached to the parameter. NULL is returned if the parameter cannot be animated. Implements ParamI.

virtual PajaTypes::uint32 get_id | ( |  | ) | const`[virtual]`

| Returns the ID of the parameter. Implements ParamI.

virtual PajaTypes::float32 get_increment | ( |  | ) | const`[virtual]`

| Returns the spinner increment. Implements ParamI.

virtual bool get_min_max | ( | PajaTypes::float32 * | pMin,
|  | PajaTypes::float32 * | pMax
| ) | `[virtual]`

  | Returns the range of the parameter. Parameters:
  pMin | pointer to a array of maximum of KEY_MAXCHANNEL floats.
  pMax | pointer to a array of maximum of KEY_MAXCHANNEL floats.
If the type of the parameter id not know use arrays of KEY_MAXCHANNEL floats. Returns: true if the range is valid, false if the range is not used. Implements ParamI.

virtual PajaTypes::uint32 get_style | ( |  | ) | const`[virtual]`

| Returns the style of the parameter. Implements ParamI.

virtual PajaTypes::uint32 get_type | ( |  | ) | const`[virtual]`

| Returns the type of the parameter. Implements ParamI.

virtual void get_val | ( | PajaTypes::int32 | t,
|  | PajaTypes::ColorC & | val
| ) | `[virtual]`

| Gets the value of the parameter at specified time.

virtual PajaTypes::uint32 load | ( | FileIO::LoadC * | pLoad | ) | `[virtual]`

| Serialize the parameter from a Demopaja input stream. Reimplemented from ParamI.

virtual void restore | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Shallow copy from a editable, see Edit::EditableI::restore(). Reimplemented from ParamI.

virtual PajaTypes::uint32 save | ( | FileIO::SaveC * | pSave | ) | `[virtual]`

| Serialize the parameter to a Demopaja output stream. Reimplemented from ParamI.

virtual void set_controller | ( | ControllerC * | cnt | ) | `[virtual]`

| Sets the controller of the parameter. Implements ParamI.

virtual void set_id | ( | PajaTypes::uint32 | id | ) | `[virtual]`

| Sets the ID of the parmeter. Implements ParamI.

virtual void set_increment | ( | PajaTypes::float32 | inc | ) | `[virtual]`

| Set spinner increment (ignored for color parameter). Implements ParamI.

virtual void set_style | ( | PajaTypes::uint32 | style | ) | `[virtual]`

| Sets the style of the parameter. Implements ParamI.

virtual PajaTypes::uint32 set_val | ( | PajaTypes::int32 | t,
|  | const PajaTypes::ColorC & | val
| ) | `[virtual]`

| Sets the value of the parameter at specified time.